]> git.ipfire.org Git - thirdparty/git.git/blame - git-bisect.sh
l10n: sv: Fix bad translation
[thirdparty/git.git] / git-bisect.sh
CommitLineData
8cc6a083 1#!/bin/sh
d025524d 2
21b55e33 3USAGE='[help|start|bad|good|new|old|terms|skip|next|reset|visualize|replay|log|run]'
243a60fb 4LONG_USAGE='git bisect help
6021be86 5 print this long help message.
06e6a745
MM
6git bisect start [--term-{old,good}=<term> --term-{new,bad}=<term>]
7 [--no-checkout] [<bad> [<good>...]] [--] [<pathspec>...]
6021be86 8 reset bisect state and start bisection.
21e5cfd8
AD
9git bisect (bad|new) [<rev>]
10 mark <rev> a known-bad revision/
11 a revision after change in a given property.
12git bisect (good|old) [<rev>...]
13 mark <rev>... known-good revisions/
14 revisions before change in a given property.
21b55e33
MM
15git bisect terms [--term-good | --term-bad]
16 show the terms used for old and new commits (default: bad, good)
5413812f 17git bisect skip [(<rev>|<range>)...]
6021be86 18 mark <rev>... untestable revisions.
38a47fd6 19git bisect next
6021be86 20 find next bisection to test and check it out.
6b87ce23 21git bisect reset [<commit>]
6021be86 22 finish bisection search and go back to commit.
38a47fd6 23git bisect visualize
6021be86 24 show bisect status in gitk.
38a47fd6 25git bisect replay <logfile>
6021be86 26 replay bisection log.
38a47fd6 27git bisect log
6021be86 28 show bisect log.
38a47fd6 29git bisect run <cmd>...
6021be86 30 use <cmd>... to automatically bisect.
243a60fb
CC
31
32Please use "git help bisect" to get the full man page.'
d025524d 33
8f321a39 34OPTIONS_SPEC=
ae2b0f15 35. git-sh-setup
dcf9c2e5 36. git-sh-i18n
8cc6a083 37
ce32660e
JS
38_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
39_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
43f9d9f3
AD
40TERM_BAD=bad
41TERM_GOOD=good
ce32660e 42
4796e823
JS
43bisect_head()
44{
45 if test -f "$GIT_DIR/BISECT_HEAD"
46 then
47 echo BISECT_HEAD
48 else
49 echo HEAD
50 fi
51}
52
8cc6a083 53bisect_autostart() {
823ea121 54 test -s "$GIT_DIR/BISECT_START" || {
3145b1a2 55 gettextln "You need to start by \"git bisect start\"" >&2
8cc6a083
LT
56 if test -t 0
57 then
04de0996
ÆAB
58 # TRANSLATORS: Make sure to include [Y] and [n] in your
59 # translation. The program will only accept English input
60 # at this point.
6021be86 61 gettext "Do you want me to do it for you [Y/n]? " >&2
8cc6a083
LT
62 read yesno
63 case "$yesno" in
64 [Nn]*)
65 exit ;;
66 esac
67 bisect_start
68 else
69 exit 1
70 fi
71 }
72}
73
74bisect_start() {
4764f464
JS
75 #
76 # Check for one bad and then some good revisions.
77 #
78 has_double_dash=0
79 for arg; do
6021be86 80 case "$arg" in --) has_double_dash=1; break ;; esac
4764f464
JS
81 done
82 orig_args=$(git rev-parse --sq-quote "$@")
83 bad_seen=0
84 eval=''
cb46d630 85 must_write_terms=0
4a6ada32 86 revs=''
24c51280
JS
87 if test "z$(git rev-parse --is-bare-repository)" != zfalse
88 then
89 mode=--no-checkout
90 else
91 mode=''
92 fi
4764f464 93 while [ $# -gt 0 ]; do
6021be86
JS
94 arg="$1"
95 case "$arg" in
96 --)
97 shift
98 break
4764f464 99 ;;
6021be86
JS
100 --no-checkout)
101 mode=--no-checkout
102 shift ;;
06e6a745
MM
103 --term-good|--term-old)
104 shift
105 must_write_terms=1
106 TERM_GOOD=$1
107 shift ;;
108 --term-good=*|--term-old=*)
109 must_write_terms=1
110 TERM_GOOD=${1#*=}
111 shift ;;
112 --term-bad|--term-new)
113 shift
114 must_write_terms=1
115 TERM_BAD=$1
116 shift ;;
117 --term-bad=*|--term-new=*)
118 must_write_terms=1
119 TERM_BAD=${1#*=}
120 shift ;;
6021be86
JS
121 --*)
122 die "$(eval_gettext "unrecognised option: '\$arg'")" ;;
123 *)
124 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
43b8ff4b
JH
125 test $has_double_dash -eq 1 &&
126 die "$(eval_gettext "'\$arg' does not appear to be a valid revision")"
127 break
6021be86 128 }
4a6ada32 129 revs="$revs $rev"
6021be86
JS
130 shift
131 ;;
4764f464 132 esac
4764f464
JS
133 done
134
4a6ada32
MM
135 for rev in $revs
136 do
137 # The user ran "git bisect start <sha1>
138 # <sha1>", hence did not explicitly specify
139 # the terms, but we are already starting to
140 # set references named with the default terms,
141 # and won't be able to change afterwards.
142 must_write_terms=1
143
144 case $bad_seen in
145 0) state=$TERM_BAD ; bad_seen=1 ;;
146 *) state=$TERM_GOOD ;;
147 esac
148 eval="$eval bisect_write '$state' '$rev' 'nolog' &&"
149 done
8cc6a083 150 #
634f2464 151 # Verify HEAD.
8cc6a083 152 #
48949a18 153 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
ce32660e 154 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
9570fc1e 155 die "$(gettext "Bad HEAD - I need a HEAD")"
634f2464 156
ee831f7d 157 #
634f2464 158 # Check if we are bisecting.
ee831f7d 159 #
d3e54c88 160 start_head=''
634f2464
CC
161 if test -s "$GIT_DIR/BISECT_START"
162 then
163 # Reset to the rev from where we started.
9d0cd91c 164 start_head=$(cat "$GIT_DIR/BISECT_START")
4796e823
JS
165 if test "z$mode" != "z--no-checkout"
166 then
1acf1171 167 git checkout "$start_head" -- ||
9c9b4f2f 168 die "$(eval_gettext "Checking out '\$start_head' failed. Try 'git bisect reset <valid-branch>'.")"
4796e823 169 fi
634f2464
CC
170 else
171 # Get rev from where we start.
172 case "$head" in
173 refs/heads/*|$_x40)
174 # This error message should only be triggered by
175 # cogito usage, and cogito users should understand
176 # it relates to cg-seek.
177 [ -s "$GIT_DIR/head-name" ] &&
382d20e3 178 die "$(gettext "won't bisect on cg-seek'ed tree")"
634f2464
CC
179 start_head="${head#refs/heads/}"
180 ;;
181 *)
9570fc1e 182 die "$(gettext "Bad HEAD - strange symbolic ref")"
634f2464
CC
183 ;;
184 esac
185 fi
8cc6a083
LT
186
187 #
634f2464 188 # Get rid of any old bisect state.
8cc6a083 189 #
823ea121 190 bisect_clean_state || exit
38a47fd6 191
ba963de8
CC
192 #
193 # Change state.
194 # In case of mistaken revs or checkout error, or signals received,
195 # "bisect_auto_next" below may exit or misbehave.
196 # We have to trap this to be able to clean up using
197 # "bisect_clean_state".
198 #
199 trap 'bisect_clean_state' 0
200 trap 'exit 255' 1 2 3 15
201
202 #
203 # Write new start state.
204 #
4796e823
JS
205 echo "$start_head" >"$GIT_DIR/BISECT_START" && {
206 test "z$mode" != "z--no-checkout" ||
207 git update-ref --no-deref BISECT_HEAD "$start_head"
208 } &&
de52f5a8 209 git rev-parse --sq-quote "$@" >"$GIT_DIR/BISECT_NAMES" &&
6ba7acff 210 eval "$eval true" &&
cb46d630
AD
211 if test $must_write_terms -eq 1
212 then
213 write_terms "$TERM_BAD" "$TERM_GOOD"
214 fi &&
6c98c054 215 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
ba963de8
CC
216 #
217 # Check if we can proceed to the next bisect state.
218 #
38a47fd6 219 bisect_auto_next
ba963de8
CC
220
221 trap '-' 0
8cc6a083
LT
222}
223
55624f9a
CC
224bisect_write() {
225 state="$1"
226 rev="$2"
737c74ee 227 nolog="$3"
55624f9a 228 case "$state" in
43f9d9f3
AD
229 "$TERM_BAD")
230 tag="$state" ;;
231 "$TERM_GOOD"|skip)
232 tag="$state"-"$rev" ;;
233 *)
234 die "$(eval_gettext "Bad bisect_write argument: \$state")" ;;
55624f9a 235 esac
ba963de8 236 git update-ref "refs/bisect/$tag" "$rev" || exit
f454cdc4 237 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
6c98c054 238 test -n "$nolog" || echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
55624f9a
CC
239}
240
c9c4e2d5
CC
241is_expected_rev() {
242 test -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
243 test "$1" = $(cat "$GIT_DIR/BISECT_EXPECTED_REV")
244}
245
c9c4e2d5
CC
246check_expected_revs() {
247 for _rev in "$@"; do
eef12a9a
JS
248 if ! is_expected_rev "$_rev"
249 then
c9c4e2d5
CC
250 rm -f "$GIT_DIR/BISECT_ANCESTORS_OK"
251 rm -f "$GIT_DIR/BISECT_EXPECTED_REV"
252 return
253 fi
254 done
255}
256
ee2314f5 257bisect_skip() {
6021be86 258 all=''
ee2314f5
CC
259 for arg in "$@"
260 do
6021be86
JS
261 case "$arg" in
262 *..*)
263 revs=$(git rev-list "$arg") || die "$(eval_gettext "Bad rev input: \$arg")" ;;
264 *)
265 revs=$(git rev-parse --sq-quote "$arg") ;;
266 esac
267 all="$all $revs"
268 done
269 eval bisect_state 'skip' $all
ee2314f5
CC
270}
271
155fc795 272bisect_state() {
8cc6a083 273 bisect_autostart
155fc795 274 state=$1
cb46d630 275 check_and_set_terms $state
155fc795
CC
276 case "$#,$state" in
277 0,*)
9570fc1e 278 die "$(gettext "Please call 'bisect_state' with at least one argument.")" ;;
43f9d9f3 279 1,"$TERM_BAD"|1,"$TERM_GOOD"|1,skip)
4796e823
JS
280 rev=$(git rev-parse --verify $(bisect_head)) ||
281 die "$(gettext "Bad rev input: $(bisect_head)")"
c9c4e2d5
CC
282 bisect_write "$state" "$rev"
283 check_expected_revs "$rev" ;;
43f9d9f3 284 2,"$TERM_BAD"|*,"$TERM_GOOD"|*,skip)
155fc795 285 shift
6bc02d56 286 hash_list=''
e3389075 287 for rev in "$@"
155fc795 288 do
a179a303 289 sha=$(git rev-parse --verify "$rev^{commit}") ||
15eaa049 290 die "$(eval_gettext "Bad rev input: \$rev")"
6bc02d56 291 hash_list="$hash_list $sha"
d3e54c88 292 done
6bc02d56
CC
293 for rev in $hash_list
294 do
295 bisect_write "$state" "$rev"
296 done
297 check_expected_revs $hash_list ;;
43f9d9f3
AD
298 *,"$TERM_BAD")
299 die "$(eval_gettext "'git bisect \$TERM_BAD' can take only one argument.")" ;;
cc9f24d0
JH
300 *)
301 usage ;;
8cc6a083 302 esac
97e1c51e
CC
303 bisect_auto_next
304}
305
8cc6a083 306bisect_next_check() {
0a5280a9 307 missing_good= missing_bad=
43f9d9f3
AD
308 git show-ref -q --verify refs/bisect/$TERM_BAD || missing_bad=t
309 test -n "$(git for-each-ref "refs/bisect/$TERM_GOOD-*")" || missing_good=t
6fecf191 310
0a5280a9
JH
311 case "$missing_good,$missing_bad,$1" in
312 ,,*)
43f9d9f3 313 : have both $TERM_GOOD and $TERM_BAD - ok
0a5280a9
JH
314 ;;
315 *,)
316 # do not have both but not asked to fail - just report.
317 false
318 ;;
43f9d9f3 319 t,,"$TERM_GOOD")
21e5cfd8 320 # have bad (or new) but not good (or old). we could bisect although
0a5280a9 321 # this is less optimum.
43f9d9f3 322 eval_gettextln "Warning: bisecting only with a \$TERM_BAD commit." >&2
0a5280a9
JH
323 if test -t 0
324 then
04de0996
ÆAB
325 # TRANSLATORS: Make sure to include [Y] and [n] in your
326 # translation. The program will only accept English input
327 # at this point.
328 gettext "Are you sure [Y/n]? " >&2
e5d3afd7
FM
329 read yesno
330 case "$yesno" in [Nn]*) exit 1 ;; esac
0a5280a9 331 fi
43f9d9f3 332 : bisect without $TERM_GOOD...
0a5280a9 333 ;;
8cc6a083 334 *)
cb46d630
AD
335 bad_syn=$(bisect_voc bad)
336 good_syn=$(bisect_voc good)
be508d3a
ÆAB
337 if test -s "$GIT_DIR/BISECT_START"
338 then
cb46d630
AD
339
340 eval_gettextln "You need to give me at least one \$bad_syn and one \$good_syn revision.
341(You can use \"git bisect \$bad_syn\" and \"git bisect \$good_syn\" for that.)" >&2
be508d3a 342 else
cb46d630
AD
343 eval_gettextln "You need to start by \"git bisect start\".
344You then need to give me at least one \$good_syn and one \$bad_syn revision.
345(You can use \"git bisect \$bad_syn\" and \"git bisect \$good_syn\" for that.)" >&2
be508d3a 346 fi
0a5280a9 347 exit 1 ;;
8cc6a083
LT
348 esac
349}
350
351bisect_auto_next() {
434d036f 352 bisect_next_check && bisect_next || :
8cc6a083
LT
353}
354
355bisect_next() {
8fe26f44 356 case "$#" in 0) ;; *) usage ;; esac
8cc6a083 357 bisect_autostart
43f9d9f3 358 bisect_next_check $TERM_GOOD
0a5280a9 359
0871984d 360 # Perform all bisection computation, display and checkout
4796e823 361 git bisect--helper --next-all $(test -f "$GIT_DIR/BISECT_HEAD" && echo --no-checkout)
5a1d31c7 362 res=$?
0a5280a9 363
6021be86 364 # Check if we should exit because bisection is finished
a7f8b8ac
TH
365 if test $res -eq 10
366 then
43f9d9f3 367 bad_rev=$(git show-ref --hash --verify refs/bisect/$TERM_BAD)
a7f8b8ac 368 bad_commit=$(git show-branch $bad_rev)
43f9d9f3 369 echo "# first $TERM_BAD commit: $bad_commit" >>"$GIT_DIR/BISECT_LOG"
a7f8b8ac 370 exit 0
f989cac9
TH
371 elif test $res -eq 2
372 then
373 echo "# only skipped commits left to test" >>"$GIT_DIR/BISECT_LOG"
43f9d9f3
AD
374 good_revs=$(git for-each-ref --format="%(objectname)" "refs/bisect/$TERM_GOOD-*")
375 for skipped in $(git rev-list refs/bisect/$TERM_BAD --not $good_revs)
f989cac9
TH
376 do
377 skipped_commit=$(git show-branch $skipped)
43f9d9f3 378 echo "# possible first $TERM_BAD commit: $skipped_commit" >>"$GIT_DIR/BISECT_LOG"
f989cac9
TH
379 done
380 exit $res
a7f8b8ac 381 fi
0a5280a9 382
5a1d31c7
CC
383 # Check for an error in the bisection process
384 test $res -ne 0 && exit $res
385
386 return 0
8cc6a083
LT
387}
388
cc9f24d0
JH
389bisect_visualize() {
390 bisect_next_check fail
235997c9
JH
391
392 if test $# = 0
393 then
c4e4644e 394 if test -n "${DISPLAY+set}${SESSIONNAME+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" &&
43b8ff4b 395 type gitk >/dev/null 2>&1
eef12a9a 396 then
c4e4644e
JK
397 set gitk
398 else
399 set git log
400 fi
235997c9
JH
401 else
402 case "$1" in
403 git*|tig) ;;
404 -*) set git log "$@" ;;
405 *) set git "$@" ;;
406 esac
407 fi
408
fc13aa3d 409 eval '"$@"' --bisect -- $(cat "$GIT_DIR/BISECT_NAMES")
cc9f24d0
JH
410}
411
8cc6a083 412bisect_reset() {
823ea121 413 test -s "$GIT_DIR/BISECT_START" || {
3145b1a2 414 gettextln "We are not bisecting."
fce0499f
CC
415 return
416 }
8cc6a083 417 case "$#" in
823ea121 418 0) branch=$(cat "$GIT_DIR/BISECT_START") ;;
305a233c 419 1) git rev-parse --quiet --verify "$1^{commit}" >/dev/null || {
6021be86
JS
420 invalid="$1"
421 die "$(eval_gettext "'\$invalid' is not a valid commit")"
422 }
423 branch="$1" ;;
8fe26f44 424 *)
6021be86 425 usage ;;
8cc6a083 426 esac
43b8ff4b
JH
427
428 if ! test -f "$GIT_DIR/BISECT_HEAD" && ! git checkout "$branch" --
4796e823 429 then
43b8ff4b 430 die "$(eval_gettext "Could not check out original HEAD '\$branch'.
15eaa049 431Try 'git bisect reset <commit>'.")"
3bb8cf88 432 fi
4796e823 433 bisect_clean_state
e204de28
JH
434}
435
38a47fd6 436bisect_clean_state() {
947a604b 437 # There may be some refs packed during bisection.
634f2464 438 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* |
947a604b
CC
439 while read ref hash
440 do
823ea121 441 git update-ref -d $ref $hash || exit
947a604b 442 done
c9c4e2d5
CC
443 rm -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
444 rm -f "$GIT_DIR/BISECT_ANCESTORS_OK" &&
823ea121
CC
445 rm -f "$GIT_DIR/BISECT_LOG" &&
446 rm -f "$GIT_DIR/BISECT_NAMES" &&
447 rm -f "$GIT_DIR/BISECT_RUN" &&
cb46d630 448 rm -f "$GIT_DIR/BISECT_TERMS" &&
9d0cd91c 449 # Cleanup head-name if it got left by an old version of git-bisect
823ea121 450 rm -f "$GIT_DIR/head-name" &&
4796e823
JS
451 git update-ref -d --no-deref BISECT_HEAD &&
452 # clean up BISECT_START last
823ea121 453 rm -f "$GIT_DIR/BISECT_START"
38a47fd6
CC
454}
455
e204de28 456bisect_replay () {
55a9fc80
ÆAB
457 file="$1"
458 test "$#" -eq 1 || die "$(gettext "No logfile given")"
459 test -r "$file" || die "$(eval_gettext "cannot read \$file for replaying")"
e204de28 460 bisect_reset
6c98c054 461 while read git bisect command rev
e204de28 462 do
c82af12a 463 test "$git $bisect" = "git bisect" || test "$git" = "git-bisect" || continue
eef12a9a
JS
464 if test "$git" = "git-bisect"
465 then
6c98c054
MV
466 rev="$command"
467 command="$bisect"
468 fi
cb46d630
AD
469 get_terms
470 check_and_set_terms "$command"
e204de28
JH
471 case "$command" in
472 start)
e9a45d75 473 cmd="bisect_start $rev"
737c74ee 474 eval "$cmd" ;;
cb46d630 475 "$TERM_GOOD"|"$TERM_BAD"|skip)
737c74ee 476 bisect_write "$command" "$rev" ;;
21b55e33
MM
477 terms)
478 bisect_terms $rev ;;
e204de28 479 *)
9570fc1e 480 die "$(gettext "?? what are you talking about?")" ;;
e204de28 481 esac
55a9fc80 482 done <"$file"
e204de28 483 bisect_auto_next
8cc6a083
LT
484}
485
a17c4101 486bisect_run () {
6021be86
JS
487 bisect_next_check fail
488
489 while true
490 do
491 command="$@"
3145b1a2 492 eval_gettextln "running \$command"
6021be86
JS
493 "$@"
494 res=$?
495
496 # Check for really bad run error.
eef12a9a
JS
497 if [ $res -lt 0 -o $res -ge 128 ]
498 then
3145b1a2
JS
499 eval_gettextln "bisect run failed:
500exit code \$res from '\$command' is < 0 or >= 128" >&2
6021be86
JS
501 exit $res
502 fi
503
504 # Find current state depending on run success or failure.
505 # A special exit code of 125 means cannot test.
eef12a9a
JS
506 if [ $res -eq 125 ]
507 then
6021be86 508 state='skip'
eef12a9a
JS
509 elif [ $res -gt 0 ]
510 then
43f9d9f3 511 state="$TERM_BAD"
6021be86 512 else
43f9d9f3 513 state="$TERM_GOOD"
6021be86
JS
514 fi
515
516 # We have to use a subshell because "bisect_state" can exit.
305a233c 517 ( bisect_state $state >"$GIT_DIR/BISECT_RUN" )
6021be86
JS
518 res=$?
519
520 cat "$GIT_DIR/BISECT_RUN"
521
43f9d9f3 522 if sane_grep "first $TERM_BAD commit could be any of" "$GIT_DIR/BISECT_RUN" \
305a233c 523 >/dev/null
eef12a9a 524 then
3145b1a2 525 gettextln "bisect run cannot continue any more" >&2
6021be86
JS
526 exit $res
527 fi
528
eef12a9a
JS
529 if [ $res -ne 0 ]
530 then
3145b1a2
JS
531 eval_gettextln "bisect run failed:
532'bisect_state \$state' exited with error code \$res" >&2
6021be86
JS
533 exit $res
534 fi
a17c4101 535
43f9d9f3 536 if sane_grep "is the first $TERM_BAD commit" "$GIT_DIR/BISECT_RUN" >/dev/null
eef12a9a 537 then
3145b1a2 538 gettextln "bisect run success"
6021be86
JS
539 exit 0;
540 fi
a17c4101 541
6021be86 542 done
a17c4101
CC
543}
544
412ff738 545bisect_log () {
9570fc1e 546 test -s "$GIT_DIR/BISECT_LOG" || die "$(gettext "We are not bisecting.")"
412ff738
SG
547 cat "$GIT_DIR/BISECT_LOG"
548}
a17c4101 549
cb46d630
AD
550get_terms () {
551 if test -s "$GIT_DIR/BISECT_TERMS"
552 then
553 {
554 read TERM_BAD
555 read TERM_GOOD
556 } <"$GIT_DIR/BISECT_TERMS"
557 fi
558}
559
560write_terms () {
561 TERM_BAD=$1
562 TERM_GOOD=$2
fe67687b
MM
563 if test "$TERM_BAD" = "$TERM_GOOD"
564 then
565 die "$(gettext "please use two different terms")"
566 fi
567 check_term_format "$TERM_BAD" bad
568 check_term_format "$TERM_GOOD" good
cb46d630
AD
569 printf '%s\n%s\n' "$TERM_BAD" "$TERM_GOOD" >"$GIT_DIR/BISECT_TERMS"
570}
571
fe67687b
MM
572check_term_format () {
573 term=$1
574 git check-ref-format refs/bisect/"$term" ||
575 die "$(eval_gettext "'\$term' is not a valid term")"
576 case "$term" in
577 help|start|terms|skip|next|reset|visualize|replay|log|run)
578 die "$(eval_gettext "can't use the builtin command '\$term' as a term")"
579 ;;
580 bad|new)
581 if test "$2" != bad
582 then
583 # In theory, nothing prevents swapping
584 # completely good and bad, but this situation
585 # could be confusing and hasn't been tested
586 # enough. Forbid it for now.
587 die "$(eval_gettext "can't change the meaning of term '\$term'")"
588 fi
589 ;;
590 good|old)
591 if test "$2" != good
592 then
593 die "$(eval_gettext "can't change the meaning of term '\$term'")"
594 fi
595 ;;
596 esac
597}
598
cb46d630
AD
599check_and_set_terms () {
600 cmd="$1"
601 case "$cmd" in
602 skip|start|terms) ;;
603 *)
604 if test -s "$GIT_DIR/BISECT_TERMS" && test "$cmd" != "$TERM_BAD" && test "$cmd" != "$TERM_GOOD"
605 then
606 die "$(eval_gettext "Invalid command: you're currently in a \$TERM_BAD/\$TERM_GOOD bisect.")"
607 fi
608 case "$cmd" in
609 bad|good)
610 if ! test -s "$GIT_DIR/BISECT_TERMS"
611 then
612 write_terms bad good
613 fi
614 ;;
21e5cfd8
AD
615 new|old)
616 if ! test -s "$GIT_DIR/BISECT_TERMS"
617 then
618 write_terms new old
619 fi
620 ;;
cb46d630
AD
621 esac ;;
622 esac
623}
624
625bisect_voc () {
626 case "$1" in
21e5cfd8
AD
627 bad) echo "bad|new" ;;
628 good) echo "good|old" ;;
cb46d630
AD
629 esac
630}
631
21b55e33
MM
632bisect_terms () {
633 get_terms
634 if ! test -s "$GIT_DIR/BISECT_TERMS"
635 then
636 die "$(gettext "no terms defined")"
637 fi
638 case "$#" in
639 0)
640 gettextln "Your current terms are $TERM_GOOD for the old state
641and $TERM_BAD for the new state."
642 ;;
643 1)
644 arg=$1
645 case "$arg" in
646 --term-good|--term-old)
647 printf '%s\n' "$TERM_GOOD"
648 ;;
649 --term-bad|--term-new)
650 printf '%s\n' "$TERM_BAD"
651 ;;
652 *)
653 die "$(eval_gettext "invalid argument \$arg for 'git bisect terms'.
654Supported options are: --term-good|--term-old and --term-bad|--term-new.")"
655 ;;
656 esac
657 ;;
658 *)
659 usage ;;
660 esac
661}
662
8cc6a083
LT
663case "$#" in
6640)
6021be86 665 usage ;;
8cc6a083 666*)
6021be86 667 cmd="$1"
cb46d630 668 get_terms
6021be86
JS
669 shift
670 case "$cmd" in
671 help)
672 git bisect -h ;;
673 start)
674 bisect_start "$@" ;;
21e5cfd8 675 bad|good|new|old|"$TERM_BAD"|"$TERM_GOOD")
6021be86
JS
676 bisect_state "$cmd" "$@" ;;
677 skip)
678 bisect_skip "$@" ;;
679 next)
680 # Not sure we want "next" at the UI level anymore.
681 bisect_next "$@" ;;
682 visualize|view)
683 bisect_visualize "$@" ;;
684 reset)
685 bisect_reset "$@" ;;
686 replay)
687 bisect_replay "$@" ;;
688 log)
689 bisect_log ;;
690 run)
691 bisect_run "$@" ;;
21b55e33
MM
692 terms)
693 bisect_terms "$@" ;;
6021be86
JS
694 *)
695 usage ;;
696 esac
8cc6a083 697esac